_G.Contours_Opt = _G.Contours_Opt or {}
Contours_Opt._path = ModPath
Contours_Opt._data_path = SavePath .. "Contours_Opt_data.txt"
Contours_Opt._data = {
	enabled_con = true,
	rainbow_Contours_Opt = false,
	Contours_Opt_color = 6,
	unique_contours = false,
	con_mode_r = 1,
	con_mode_s = 1,
	con_mode_b = 1,
	con_spd = 50
}

function Contours_Opt:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self._data ) )
		file:close()
	end
end

function Contours_Opt:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	end
end

Hooks:Add("MenuManagerInitialize", "MenuManagerInitializeCon", function(menu_manager)
	MenuCallbackHandler.Contours_Opt_on_color_change_callback = function(self,item)
		Contours_Opt._data.Contours_Opt_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.con_regular_mode_callback = function(self,item)
		Contours_Opt._data.con_mode_r = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.con_specials_mode_callback = function(self,item)
		Contours_Opt._data.con_mode_s = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.con_bosses_mode_callback = function(self,item)
		Contours_Opt._data.con_mode_b = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.con_spd_change_callback = function(self,item)
		Contours_Opt._data.con_spd = math.round(item:value())
		Contours_Opt:Save()
	end
	MenuCallbackHandler.callback_enabled_con = function(self,item)
		local value = item:value() == "on"
		Contours_Opt._data.enabled_con = value
		Contours_Opt:Save()
	end
	MenuCallbackHandler.callback_enabled_unique_contours = function(self,item)
		local value = item:value() == "on"
		Contours_Opt._data.unique_contours = value
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_medic_color_change_callback = function(self,item)
		Contours_Opt._data.medic_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_shield_color_change_callback = function(self,item)
		Contours_Opt._data.shield_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_sniper_color_change_callback = function(self,item)
		Contours_Opt._data.sniper_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_taser_color_change_callback = function(self,item)
		Contours_Opt._data.taser_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_spooc_color_change_callback = function(self,item)
		Contours_Opt._data.spooc_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_tank_color_change_callback = function(self,item)
		Contours_Opt._data.tank_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_tank_hw_color_change_callback = function(self,item)
		Contours_Opt._data.tank_hw_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_shield_capt_color_change_callback = function(self,item)
		Contours_Opt._data.shield_captain_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_phxvip_color_change_callback = function(self,item)
		Contours_Opt._data.phalanx_vip_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_tank_medic_color_change_callback = function(self,item)
		Contours_Opt._data.tank_medic_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_tank_mini_color_change_callback = function(self,item)
		Contours_Opt._data.tank_mini_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_boss_color_change_callback = function(self,item)
		Contours_Opt._data.boss_color = item:value()
		Contours_Opt:Save()
	end

	--Resmod units

	MenuCallbackHandler.Uniq_summers_color_change_callback = function(self,item)
		Contours_Opt._data.summers_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_boom_summers_color_change_callback = function(self,item)
		Contours_Opt._data.boom_summers_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_taser_summers_color_change_callback = function(self,item)
		Contours_Opt._data.taser_summers_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_medic_summers_color_change_callback = function(self,item)
		Contours_Opt._data.medic_summers_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_spring_color_change_callback = function(self,item)
		Contours_Opt._data.spring_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_headless_hatman_color_change_callback = function(self,item)
		Contours_Opt._data.headless_hatman_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_plananx_minion_assault_color_change_callback = function(self,item)
		Contours_Opt._data.plananx_minion_assault_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_taser_titan_color_change_callback = function(self,item)
		Contours_Opt._data.taser_titan_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_taser_titan_reaper_color_change_callback = function(self,item)
		Contours_Opt._data.taser_titan_reaper_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_heavy_swat_sniper_color_change_callback = function(self,item)
		Contours_Opt._data.heavy_swat_sniper_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_tank_titan_color_change_callback = function(self,item)
		Contours_Opt._data.tank_titan_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_tank_titan_assault_color_change_callback = function(self,item)
		Contours_Opt._data.tank_titan_assault_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_hrt_titan_color_change_callback = function(self,item)
		Contours_Opt._data.hrt_titan_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_omnia_lpf_color_change_callback = function(self,item)
		Contours_Opt._data.omnia_lpf_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_enforcer_assault_color_change_callback = function(self,item)
		Contours_Opt._data.enforcer_assault_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_boom_color_change_callback = function(self,item)
		Contours_Opt._data.boom_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_city_swat_titan_color_change_callback = function(self,item)
		Contours_Opt._data.city_swat_titan_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_city_swat_titan_assault_color_change_callback = function(self,item)
		Contours_Opt._data.city_swat_titan_assault_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Uniq_fbi_vet_color_change_callback = function(self,item)
		Contours_Opt._data.fbi_vet_color = item:value()
		Contours_Opt:Save()
	end
	MenuCallbackHandler.Contours_Opt_closed = function(self)
		Contours_Opt:Save()
	end

	Contours_Opt:Load()
	MenuHelper:LoadFromJsonFile(Contours_Opt._path .. "menu/options.txt", Contours_Opt, Contours_Opt._data)
	MenuHelper:LoadFromJsonFile(Contours_Opt._path .. "menu/resmod_units_options.txt", Contours_Opt, Contours_Opt._data)
end)